/* mbed PwmIn Library UPDATED 
 * Copyright (c) 2008-2010, sford
 *------------------------------------------------------------------------------
 *Rise and Fall libraries were giving  warning: "mbed::InterruptIn::rise(T *, M) 
 *[with T=PwmIn, M=void (PwmIn::*)()] was declared deprecated". As of that ,
 *I updated the code with the proper functions.
 *_p.rise(this, &PwmIn::rise); changed with _p.rise(callback(this, &PwmIn::rise));
 *_p.fall(this, &PwmIn::rise); changed with _p.fall(callback(this, &PwmIn::rise));
 *I also changed some methods names  beacause I think they could generate some 
 *confusion while progamming together with PwmOut. 
 *-------------------------------------------------------------dpalombi
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
#include "PwmIn.h"
 
 PwmIn::PwmIn(PinName p) : _p(p) {
    _p.rise(callback(this, &PwmIn::rise));
    _p.fall(callback(this, &PwmIn::fall));
    _period = 0.0;
    _pulsewidth = 0.0;
    _t.start();
}
 
float PwmIn::periodIn() {
    return _period;
}
 
float PwmIn::pulsewidthIn() {
    return _pulsewidth;
}
 
float PwmIn::dutycycleIn() {
    return _pulsewidth / _period;
}
 
void PwmIn::rise() {
    _period = _t.read();
    _t.reset();
}
 
void PwmIn::fall() {
    _pulsewidth = _t.read();
}